--- head/asterisk/channels/chan_sip.c	2005-02-07 08:56:43.000000000 -0600
+++ asterisk/channels/chan_sip.c	2005-02-08 00:17:25.000000000 -0600
@@ -5246,6 +5246,7 @@
 	struct sip_request *req;
 	struct sip_pvt *p2;
 	struct ast_channel *chan = NULL, *peer = NULL;
+	struct sip_user *user;	
 
 	req = oreq;
 	if (!req)
@@ -5298,13 +5299,15 @@
 	if ((a = strchr(c, ';'))) 
 		*a = '\0';
 	
-
 	if ((a2 = strchr(c2, '@')))
 		*a2 = '\0';
 
 	if ((a2 = strchr(c2, ';'))) 
 		*a2 = '\0';
 	
+	user = find_user(c2);
+	if (!ast_strlen_zero(user->context))
+		strncpy(p->context, user->context, sizeof(p->context) - 1);
 	
 	if (sip_debug_test_pvt(p)) {
 		ast_verbose("Looking for %s in %s\n", c, p->context);
@@ -6953,8 +6956,32 @@
 static void parse_moved_contact(struct sip_pvt *p, struct sip_request *req)
 {
 	char tmp[256] = "";
+	char tmp2[256] = "";
 	char *s, *e;
+	char *c, *a;
+	struct sip_user *user;
+
 	strncpy(tmp, get_header(req, "Contact"), sizeof(tmp) - 1);
+
+	if (!ast_strlen_zero(p->owner->context)) {
+		strncpy(tmp2, get_header(req, "To"), sizeof(tmp2) -1);
+		c = ditch_braces(tmp2);
+		if (strncmp(c, "sip:", 4)) {
+			ast_log(LOG_NOTICE, "From address missing 'sip:', using it anyway\n");
+		} else
+			c += 4;
+		a = strchr(c, '@');
+		if (a)
+			*a = '\0';
+		a = strchr(c, ':');
+		if (a)
+			*a = '\0';
+	}	
+
+	user=find_user(c);
+	if (c)
+		strncpy(p->owner->context, user->context, sizeof(p->owner->context) - 1);
+	
 	s = ditch_braces(tmp);
 	e = strchr(s, ';');
 	if (e)
